
import os
import pytz
from socle.menu import choice
from socle.atomic import AtomicWrite

def available_locales():
    for line in open("/etc/locale.gen").readlines():
        if "#" in line:
            line, _ = line.split("#", 1)
        line = line.strip()
        if not line:
            continue
        yield line.split(" ", 1)[0]

def reconfigure_default_locale():
    selected_locale = choice([(j,j) for j in available_locales()],
        "Set default locale",
        "Following locales are available on your system according to /etc/locale.gen")
    with AtomicWrite("/etc/default/locale") as fh:
        fh.write("# Generated by socle\n")
        fh.write("LANG=\"%s\"\n" % selected_locale)

if os.path.exists("/etc/locale.gen"):
    MENU_ENTRIES = (
        ("Set default locale", reconfigure_default_locale),
    )
else:
    MENU_ENTRIES = ()
    print "It seems /etc/locale.gen does not exist, are you sure locales are configured properluy? Disabling default locale selection for now"

